function varargout = REQSegment(varargin)
% REQSEGMENT MATLAB code for REQSegment.fig
%      REQSEGMENT, by itself, creates a new REQSEGMENT or raises the existing
%      singleton*.
%
%      H = REQSEGMENT returns the handle to a new REQSEGMENT or the handle to
%      the existing singleton*.
%
%      REQSEGMENT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in REQSEGMENT.M with the given input arguments.
%
%      REQSEGMENT('Property','Value',...) creates a new REQSEGMENT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before REQSegment_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to REQSegment_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help REQSegment

% Last Modified by GUIDE v2.5 18-Jan-2016 20:52:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @REQSegment_OpeningFcn, ...
                   'gui_OutputFcn',  @REQSegment_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before REQSegment is made visible.
function REQSegment_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to REQSegment (see VARARGIN)

% Choose default command line output for REQSegment
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes REQSegment wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = REQSegment_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% Initialize GUI
I3 = imread('Wait4Input.jpg');
axes(handles.stFig);
imshow(I3);
axes(handles.outFig);
imshow(I3);
pause(0.5)
% load Img5SLIC.mat
% handles.SLIC_labels = labels;
% guidata(hObject,handles);
% clear labels

% --- Executes on button press in inData.
function inData_Callback(hObject, eventdata, handles)
% hObject    handle to inData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Fetch Inputs

% Fetch image
oldpath = pwd;
[filename, pathname] = uigetfile('*.png;*.jpeg;*.jpg;*.bmp'...
        ,'Select image file for segmentation');
if (filename == 0)
    errordlg('      No selection made      ','Input Error');
    return; % If no file selected, exit!
end
cd(pathname);
% Lines 105 - 114 were required to resize the image for our screen size during
% data collection. Comment these lines if not applicable. Uncomment line 115.
I = uint8(ones(1050,1680,3));
temp = imread(filename);
% Portrait - Uncomment 108 for portrait images and comment 111
Iresized = imresize(temp,[1050, (1050/(size(temp,1)/size(temp,2)))],'bicubic');
% Landscape  - Uncomment 111 for portrait images and comment 108
% Iresized = imresize(temp,[(1680/(size(temp,2)/size(temp,1))),1680],'bicubic');
strtX = 1+(1050-size(Iresized,1))/2;
strtY = 1+(1680-size(Iresized,2))/2;
I(strtX:strtX+(size(Iresized,1)-1),strtY:strtY+(size(Iresized,2)-1),:) = Iresized(:,:,:);
% I = imread(filename);
handles.I1 = I;
cd(oldpath);
guidata(hObject,handles);
cd(oldpath);
axes(handles.stFig);
imshow(handles.I1);

% Fetch eyetracking data
oldpath = pwd;
[filename, pathname] = uigetfile('*.xls;*.xlsx;*.csv','Select excel file with eye-tracking data');
if (filename == 0)
    errordlg('      No selection made      ','Input Error');
    return; % If no file selected, exit!
end
cd(pathname);
handles.fixData = xlsread(filename);
guidata(hObject,handles);
cd(oldpath);
I = handles.I1;
fixData = handles.fixData;

% Set default values
numPix = 25;
cfact = 10;
numFix = 15;
xbound = 'moderate';
ybound = 'moderate';
outlierCombo = [0 1 0; 0 1 0];

set(handles.segSize, 'string', num2str(numPix));
set(handles.cmpfact, 'string', num2str(cfact));
set(handles.numFixPts, 'string', num2str(numFix));
set(handles.xM, 'Value', 1);
set(handles.yM, 'Value', 1);

I4 = imread('genRes.jpg');
axes(handles.outFig);
imshow(I4);

% Perform REQ Clustering of fixation points
[labels, ~] =  slicmex(I,numPix,cfact);
% figure
% imagesc(labels)
pause(0.5)
% save(sprintf('%s_SLIClabels.mat',filename),'labels');
x1 = fixData(1:end,1);
y1 = fixData(1:end,2);

nRows = size(I,1);
nCols = size(I,2);    
l = 1;

% Prune points falling outside screen size
% Happens for loss of attention by viewer
for k = 1:length(x1)
    if ((x1(k) <= nCols) && (x1(k) >= 1))          % inverted indices in MATLAB representations
       if ((y1(k) <= nRows) && (y1(k) >= 1))
            xtemp(l) = round(x1(k));
            ytemp(l) = round(y1(k));
       end
    end
    l = l+1;
end
x1new = nonzeros(xtemp);
y1new = nonzeros(ytemp);
clear x1 y1
xtemp = round(x1new);
ytemp = round(y1new);

if (length(xtemp) < length(ytemp))
    ytemp = ytemp(1:length(xtemp));
elseif (length(ytemp) < length(xtemp))
    xtemp = xtemp(1:length(ytemp));
end

% Get unique labels
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
handles.segLabels = seg;
guidata(hObject,handles);

% Perform clustering
[idx_X,idx_Y,K] = clusterFixationPoints(ytemp,xtemp);

clusColor = ['r';'g';'b';'c';'m';'y';'w';'k'];
plotColor = ['r.';'g.';'b.';'c.';'m.';'y.';'w.';'k.'];
x = cell(K,1);
y = cell(K,1);

axes(handles.stFig);
imshow(I);

for n = 1:K
    x{n} = xtemp(idx_X==n,1);
    y{n} = ytemp(idx_Y==n,1);
    [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound); % Outlier Removal
    x1{n} = round(x1{n});
    y1{n} = round(y1{n}); 
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
% save(sprintf('%s_REQ.mat',filename),'x1','y1');
handles.numSeg = K;
guidata(hObject,handles);
% Perform Segmentation for each cluster
clear n
for n = 1:K
    clusResult{n} = getSegResult(I, nRows, nCols, y1{n}, x1{n},handles.segLabels, numFix);
    clear Vs v2 segImg IR IG IB
end  
handles.cc = 1; % Current Cluster
guidata(hObject,handles);
axes(handles.outFig);
imshow(clusResult{handles.cc});
set(handles.clusC, 'BackgroundColor', clusColor(handles.cc));
handles.PltClr = plotColor;
handles.cR = clusResult;
handles.x = x;
handles.y = y;
handles.x1 = x1;
handles.y1 = y1;
handles.nRows = nRows;
handles.nCols = nCols;
handles.outlierCombo = outlierCombo;
guidata(hObject,handles);

% For Future: Move repeated code in callbacks into a separate function

function segSize_Callback(hObject, eventdata, handles)
% hObject    handle to segSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of segSize as text
%        str2double(get(hObject,'String')) returns contents of segSize as a double


% --- Executes during object creation, after setting all properties.
function segSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to segSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in segSizeAdd.
function segSizeAdd_Callback(hObject, eventdata, handles)
% hObject    handle to segSizeAdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
numPix = str2double(get(handles.segSize,'string'));
numPix = numPix + 1;
set(handles.segSize, 'string', num2str(numPix));
numFix = str2double(get(handles.numFixPts,'string'));
cfact = str2double(get(handles.cmpfact,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] =  slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in segSizeSub.
function segSizeSub_Callback(hObject, eventdata, handles)
% hObject    handle to segSizeSub (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

numPix = str2double(get(handles.segSize,'string'));
numPix = numPix - 1;
set(handles.segSize, 'string', num2str(numPix));
numFix = str2double(get(handles.numFixPts,'string'));
cfact = str2double(get(handles.cmpfact,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] =  slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols,y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

function cmpfact_Callback(hObject, eventdata, handles)
% hObject    handle to cmpfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cmpfact as text
%        str2double(get(hObject,'String')) returns contents of cmpfact as a double


% --- Executes during object creation, after setting all properties.
function cmpfact_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cmpfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cfactAdd.
function cfactAdd_Callback(hObject, eventdata, handles)
% hObject    handle to cfactAdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cfact = str2double(get(handles.cmpfact,'string'));
cfact = cfact + 5;
set(handles.cmpfact, 'string', num2str(cfact));
numFix = str2double(get(handles.numFixPts,'string'));
numPix = str2double(get(handles.segSize,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols,y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in cfactSub.
function cfactSub_Callback(hObject, eventdata, handles)
% hObject    handle to cfactSub (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cfact = str2double(get(handles.cmpfact,'string'));
cfact = cfact - 5;
set(handles.cmpfact, 'string', num2str(cfact));
numFix = str2double(get(handles.numFixPts,'string'));
numPix = str2double(get(handles.segSize,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] =  slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols,y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

function numFixPts_Callback(hObject, eventdata, handles)
% hObject    handle to numFixPts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numFixPts as text
%        str2double(get(hObject,'String')) returns contents of numFixPts as a double


% --- Executes during object creation, after setting all properties.
function numFixPts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numFixPts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in numFixAdd.
function numFixAdd_Callback(hObject, eventdata, handles)
% hObject    handle to numFixAdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
numFix = str2double(get(handles.numFixPts,'string'));
numFix = numFix + 1;
set(handles.numFixPts, 'string', num2str(numFix));
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] =  slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in numFixSub.
function numFixSub_Callback(hObject, eventdata, handles)
% hObject    handle to numFixSub (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
numFix = str2double(get(handles.numFixPts,'string'));
numFix = numFix - 1;
set(handles.numFixPts, 'string', num2str(numFix));
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end

if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols,y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

function clusC_Callback(hObject, eventdata, handles)
% hObject    handle to clusC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clusC as text
%        str2double(get(hObject,'String')) returns contents of clusC as a double



% --- Executes during object creation, after setting all properties.
function clusC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clusC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in nC.
function nC_Callback(hObject, eventdata, handles)
% hObject    handle to nC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.cc = handles.cc + 1;
clusColor = ['r';'g';'b';'c';'m';'y';'w';'k'];
if (handles.cc <= handles.numSeg)
    guidata(hObject,handles);
    axes(handles.outFig);
    imshow(handles.cR{handles.cc});
    set(handles.clusC, 'BackgroundColor', clusColor(handles.cc));
else
    I5 = imread('Default.jpg');
    axes(handles.outFig);
    imshow(I5);
end

% --- Executes on button press in pc.
function pc_Callback(hObject, eventdata, handles)
% hObject    handle to pc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.cc = handles.cc - 1;
clusColor = ['r';'g';'b';'c';'m';'y';'w';'k'];
if ((handles.cc > 0)&&(handles.cc <= handles.numSeg))
    guidata(hObject,handles);
    axes(handles.outFig);
    imshow(handles.cR{handles.cc});
    set(handles.clusC, 'BackgroundColor', clusColor(handles.cc));
else
    I5 = imread('Default.jpg');
    axes(handles.outFig);
    imshow(I5);
end

% --- Executes on button press in xL.
function xL_Callback(hObject, eventdata, handles)
% hObject    handle to xL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of xL
xL_st = get(hObject,'Value');
if (xL_st == 1)
    set(handles.xM, 'Value', 0);
    set(handles.xH, 'Value', 0);
    handles.outlierCombo(1,:) = [1,0,0];
    guidata(hObject,handles);
    xbound = 'low';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in xM.
function xM_Callback(hObject, eventdata, handles)
% hObject    handle to xM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of xM
xM_st = get(hObject,'Value');
if (xM_st == 1)
    set(handles.xL, 'Value', 0);
    set(handles.xH, 'Value', 0);    
    handles.outlierCombo(1,:) = [0,1,0];
    guidata(hObject,handles);
    xbound = 'moderate';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in xH.
function xH_Callback(hObject, eventdata, handles)
% hObject    handle to xH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of xH
xH_st = get(hObject,'Value');
if (xH_st == 1)
    set(handles.xL, 'Value', 0);
    set(handles.xM, 'Value', 0);      
    handles.outlierCombo(1,:) = [0,0,1];
    guidata(hObject,handles);
    xbound = 'high';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(2,1) == 1)
    ybound = 'low';
elseif (outlier(2,3) == 1)
    ybound = 'high';
else
    ybound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in yL.
function yL_Callback(hObject, eventdata, handles)
% hObject    handle to yL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of yL
yL_st = get(hObject,'Value');
if (yL_st == 1)
    set(handles.yH, 'Value', 0);
    set(handles.yM, 'Value', 0);    
    handles.outlierCombo(2,:) = [1,0,0];
    guidata(hObject,handles);
    ybound = 'low';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in yM.
function yM_Callback(hObject, eventdata, handles)
% hObject    handle to yM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of yM
yM_st = get(hObject,'Value');
if (yM_st == 1)
    set(handles.yL, 'Value', 0);
    set(handles.yH, 'Value', 0);    
    handles.outlierCombo(2,:) = [0,1,0];
    guidata(hObject,handles);
    ybound = 'moderate';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);

% --- Executes on button press in yH.
function yH_Callback(hObject, eventdata, handles)
% hObject    handle to yH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of yH
yH_st = get(hObject,'Value');
if (yH_st == 1)
    set(handles.yL, 'Value', 0);
    set(handles.yM, 'Value', 0);    
    handles.outlierCombo(2,:) = [0,0,1];
    guidata(hObject,handles);
    ybound = 'high';
end
cfact = str2double(get(handles.cmpfact,'string'));
numPix = str2double(get(handles.segSize,'string'));
numFix = str2double(get(handles.numFixPts,'string'));
nRows = handles.nRows;
nCols = handles.nCols;
outlier = handles.outlierCombo;
if (outlier(1,1) == 1)
    xbound = 'low';
elseif (outlier(1,3) == 1)
    xbound = 'high';
else
    xbound = 'moderate'; % default
end
I = handles.I1;
axes(handles.stFig);
imshow(I);
x = handles.x;
y = handles.y;
x1Org = handles.x1;
y1Org = handles.y1;
K = handles.numSeg;
plotColor = handles.PltClr;
for n = 1:K
    if (n == handles.cc)
        [x1{n}, y1{n}] = keepPtsWithinStd(x{n}, y{n},xbound,ybound);
        x1{n} = round(x1{n});
        y1{n} = round(y1{n});
    else
        x1{n} = x1Org{n};
        y1{n} = y1Org{n};        
    end        
    hold on
    plot(x1{n},y1{n},plotColor(n,:),'MarkerSize',15) ;  
end
[labels, ~] = slicmex(I,numPix,cfact);
uniqLabels = unique(labels);
seg = cell(length(uniqLabels),1);
for i=1:length(uniqLabels)
    seg{i,1} = find(labels == uniqLabels(i));
end
clusResult{handles.cc} = getSegResult(I,nRows, nCols, y1{handles.cc}, x1{handles.cc}, seg, numFix);
axes(handles.outFig);
imshow(clusResult{handles.cc});
handles.cR{handles.cc} = clusResult{handles.cc};
guidata(hObject,handles);
