function [K,REQ,Rth] = REQ_computation(Vs,Ds)

% Find the REQ values
l = diag(Ds);
N = length(l);
l_max = l(N);
sig_r = sqrt(2*(l_max^2)/N);

for i = 1:N
    REQ(i,:) = (1-l(i))/sig_r;
end

% Set REQ threshold = 16
Rth = 16;
REQMin = REQ(1)-Rth;

% Retain eigen values with REQ < Rth
K = 1;
for j = 1:N
    if REQ(j) >= REQMin 
        l_sel(K,:) = l(j);
        V_sel(:,K) = Vs(:,j);
        K = K + 1;
    else
        break;
    end
end
K = K - 1; % K starts at 1 not 0, actual segments is 1 less than count.






    
    


    
