function [idx_X,idx_Y, K] = clusterFixationPoints(ptsX, ptsY)

% Compute adjacency matrix
display('Starting adjacency matrix calculation...');
sigX = 20;
adjPts = zeros(size(ptsY,1),size(ptsX,2));
for i = 1:size(ptsY,1)
    for j = 1:size(ptsX,1)
        euclidDist = sqrt((ptsY(i) - ptsY(j))^2 + (ptsX(i) - ptsX(j))^2);
        if (euclidDist < 300) % r= 300
            adjPts(i,j) = exp(-euclidDist/(sigX^2));
        else
            adjPts(i,j) = 0;
        end
        clear euclidDist
    end
end

% For Future: Improve adacency calculation by making use of symmetry

adjRows = size(adjPts,1);
adjCols = size(adjPts,2);

D = zeros(adjRows,adjCols);
for i = 1:adjRows
    D(i,i) = sum(adjPts(i,:),2);
end

L = D-adjPts;
temp = inv(D)*L;

[V1,D1] = eig(temp);

Ds=diag(sort(diag(D1),'ascend'));
[~, ind]=sort(diag(D1),'ascend');
Vs = V1(:,ind); 

[K,~,~] = REQ_computation(Vs,Ds); % Fix number of clusters 

v2 = Vs(:,2);

thres =  mean(v2);

v2(v2>thres) = 1;
v2(v2~=1) = 2;

if(K == 1)
    idx_X(1:length(v2),1) = 1;
    idx_Y(1:length(v2),1) = 1;
elseif(K == 2)
    idx_X(v2 == 1) = 1;
    idx_X(v2 ~=1) = 2;
    idx_Y(v2 == 1) = 1;
    idx_Y(v2 ~=1) = 2;
    idx_X = idx_X';
    idx_Y = idx_Y';
else
    ind1 = find(v2 == 1);
    ind2 = find(v2 ~=1);
    V_sel = Vs(:,3:end);
    [idx_X, idx_Y] = otherVecs(ind1,ind2,V_sel,K);    
end






















